;-------------------------------------------------------------------------------------
;Pin assign
;	RAMMY	FUNCTION	PORT PIN      PIN PORT	FUNCTION	RAMMY
;					_____
;CTRL2.D6 (!R)	!RESET		PC6  1 |o    |28  PC5 	ADC5 SCL	NC
;	RXD	RXD		PD0  2 |     |27  PC4 	ADC4 SDA	NC
;	TXD	TXD		PD1  3 |     |26  PC3 	ADC3		NC Tx
;	RTS	INT0		PD2  4 |     |25  PC2 	ADC2		NC Rx
;	CTS	INT1 OC2B	PD3  5 |     |24  PC1 	ADC1		BAUD1 (RIGHT)
;	NC	XCK  T0		PD4  6 |     |23  PC0 	ADC0		BAUD0 (LEFT)
;	+5V	-		VCC  7 |     |22  GND	-		GND
;	GND	-		GND  8 |     |21  AREF	-		0.1uF----|i.
;	OSC_IN	XTAL1 TOSC1	PB6  9 |     |20  AVCC	-		+5V
;	NC	XTAL2 TOSC2	PB7  10|     |19  PB5 	SCK		CTRL2.D5 (!WR)
;	NC	OC0B T1		PD5  11|     |18  PB4 	MISO		CTRL2.D4 (!RD)
;	OSC0	OC0A AIN0	PD6  12|     |17  PB3 	MOSI OC2A	CTRL2.D3 (D3)
;	OSC1	AIN1		PD7  13|     |16  PB2 	!SS  OC1B	CTRL2.D2 (D2)
;CTRL2.D0 (D0)	CLKO ICP1	PB0  14|_____|15  PB1 	     OC1A	CTRL2.D1 (D1)
;
;	*CTRL2.D6 (!R)  TH (foCXID) s
;		
;	*D0-D3̏l 0b1001 (0x09)
;		
;		
;-------------------------------------------------------------------------------------
;I/O bit number
	;Port B
	.EQU	PN_OSC	= 6
	.EQU	PN_WR	= 5
	.EQU	PN_RD	= 4
	.EQU	PN_DATA	= 0

	;Port C
	.EQU	PN_RESET= 6
	.EQU	PN_SCL	= 5
	.EQU	PN_SDA	= 4
	.EQU	PN_BAUD0= 1	;Baudrate select
	.EQU	PN_BAUD1= 0	;Baudrate select
	
	;Port D
	.EQU	PN_RXD	= 0
	.EQU	PN_TXD	= 1
	.EQU	PN_RTS	= 2	;RTS (Request to Send: Mv), o
	.EQU	PN_CTS	= 3	;CTS (Clear to Send: M), M
	.EQU	PN_OSC0	= 6	;Oscillator Select
	.EQU	PN_OSC1	= 7	;Oscillator Select
;-------------------------------------------------------------------------------------
;R}h			;R}hz	߂l
	.EQU	C_NULL	= 0	;1		-
	.EQU	C_FIFO	= 4	;1		LOW = 1 = Rxd̋󂫂, HIGH = 1 = Txd̋󂫂
	.EQU	C_OSC	= 5	;1		Oscillator Clock (00MHz)
	.EQU	C_BAUD	= 6	;1		{[[g (0x73 = 115kbps)
	.EQU	C_RXD	= 7	;1		Mf[^
	.EQU	C_TXD	= 8	;3 (Mf[^)	-

	.EQU	FALSE = 0
	.EQU	TRUE = 1
;-------------------------------------------------------------------------------------
.CSEG	;FlashROMR[hZOg
.ORG	0x0000	;荞݃xN^[
INTVCT00:	RJMP	 RESET	 ;Zbg
INTVCT01:	RJMP	 EXT_INT0	 ;O荞ݗv0
INTVCT02:	RJMP	 EXT_INT1	 ;O荞ݗv1
INTVCT03:	RJMP	 PC_INT0	 ;sω荞ݗv0
INTVCT04:	RJMP	 PC_INT1	 ;sω荞ݗv1
INTVCT05:	RJMP	 PC_INT2	 ;sω荞ݗv2
INTVCT06:	RJMP	 WDT_OVF	 ;WDT v
INTVCT07:	RJMP	 TIM2_COMPA	 ;Timer/Counter2 rAv
INTVCT08:	RJMP	 TIM2_COMPB	 ;Timer/Counter2 rBv
INTVCT09:	RJMP	 TIM2_OVF	 ;Timer/Counter2 I[o[t[
INTVCT0A:	RJMP	 TIM1_CAPT	 ;Timer/Counter1 ߊl()
INTVCT0B:	RJMP	 TIM1_COMPA	 ;Timer/Counter1 rAv
INTVCT0C:	RJMP	 TIM1_COMPB	 ;Timer/Counter1 rBv
INTVCT0D:	RJMP	 TIM1_OVF	 ;Timer/Counter1 I[o[t[
INTVCT0E:	RJMP	 TIM0_COMPA	 ;Timer/Counter0 rAv
INTVCT0F:	RJMP	 TIM0_COMPB	 ;Timer/Counter0 rBv
INTVCT10:	RJMP	 TIM0_OVF	 ;Timer/Counter0 I[o[t[
INTVCT11:	RJMP	 SPI_STC	 ;SPI]
INTVCT12:	RJMP	 USART_RXC	 ;USART M
INTVCT13:	RJMP	 USART_UDRE	 ;USART MBUFFER 
INTVCT14:	RJMP	 USART_TXC	 ;USART M
INTVCT15:	RJMP	 ADCCOMP	 ;ADCϊ 
INTVCT16:	RJMP	 EE_RDY	 ;EEPROM 
INTVCT17:	RJMP	 ANA_COMP	 ;ANALOGr o͑J
INTVCT18:	RJMP	 TWI	 ;2SPI ԕω
INTVCT19:	RJMP	 SPM_RDY	 ;SPMߑ
;-------------------------------------------------------------------------------------
.DSEG
.ORG	SRAM_START
	D_OSC_MHZ:	.BYTE	1		;Oscillator Clock
	D_BAUD_KBPS:	.BYTE	1		;Baudrate

	D_CMD:		.BYTE	3		;R}hz (Command, Data Low, Data High)
	D_CMD_WR:	.BYTE	1		;R}h݈ʒu
	D_CMD_RD:	.BYTE	1		;R}h̎s, KhCuǂݎl

	D_RXD_PC:	.BYTE	1		;PCMf[^̐[ʒu, PC <= MD
	D_RXD_MD:	.BYTE	1		;MDǂ񂾃f[^̐[ʒu
	D_TXD_MD:	.BYTE	1		;MD痈f[^̐[ʒu, MD <= PC
	D_TXD_PC:	.BYTE	1		;PC֑f[^̐[ʒu
	.EQU		SIZE_RXD = 128		;MFIFOTCY
	.EQU		SIZE_TXD = 128		;MFIFOTCY
	D_RXD:		.BYTE	SIZE_RXD	;MFIFO
	D_TXD:		.BYTE	SIZE_TXD	;MFIFO
	;-------------------------------------------------------------------------------------
	;Baudrate with Oscillator
	;11MHz
	.EQU	UBRR_11MHz_19k	= 11059200 / 8 /  19200 - 1
	.EQU	UBRR_11MHz_56k	= 11059200 / 8 /  57600 - 1
	.EQU	UBRR_11MHz_115k	= 11059200 / 8 / 115200 - 1
	;14MHz
	.EQU	UBRR_14MHz_19k	= 14745600 / 8 /  19200 - 1
	.EQU	UBRR_14MHz_56k	= 14745600 / 8 /  57600 - 1
	.EQU	UBRR_14MHz_115k	= 14745600 / 8 / 115200 - 1
	;16MHz
	.EQU	UBRR_16MHz_19k	= 16000000 / 8 /  19200 - 1
	.EQU	UBRR_16MHz_56k	= 16000000 / 8 /  57600 - 1 + 1	;ZƏ_B
	.EQU	UBRR_16MHz_115k	= 16000000 / 8 / 115200 - 1
	;18MHz
	.EQU	UBRR_18MHz_19k	= 18432000 / 8 /  19200 - 1
	.EQU	UBRR_18MHz_56k	= 18432000 / 8 /  57600 - 1
	.EQU	UBRR_18MHz_115k	= 18432000 / 8 / 115200 - 1

.CSEG			;2bit = None, Right(115k), Left(19k), Center(56k)
			;2bit = 11MHz, 14MHz, 16MHz, 18MHz
	D_OSC_BAUD:	.DB 0, UBRR_11MHz_115k, UBRR_11MHz_19k, UBRR_11MHz_56k
			.DB 0, UBRR_14MHz_115k, UBRR_14MHz_19k, UBRR_14MHz_56k
			.DB 0, UBRR_16MHz_115k, UBRR_16MHz_19k, UBRR_16MHz_56k
			.DB 0, UBRR_18MHz_115k, UBRR_18MHz_19k, UBRR_18MHz_56k
;-------------------------------------------------------------------------------------
